import type { IPriorityQueue } from './priority-queue.type';
/**
 * Create a priority queue, implementation based on a max-heap.
 *
 * For example:
 *
 *  createPriorityQueue<number>((x, y) => x - y) // => The top element has a maximum value.
 *  createPriorityQueue<number>((x, y) => y - x) // => The top element has a minimum value.
 *
 * @param cmp   Comparison function, if the result > 0, the element on the left
 *              side of the operator has higher precedence.
 * @returns
 */
export declare function createPriorityQueue<T>(cmp: (x: T, y: T) => -1 | 0 | 1 | number): IPriorityQueue<T>;
